MainApplication/Controllers/TopicController.cs
using MainApplication.Models;
using MainApplication.token;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Web;
using System.Web.Mvc;

namespace MainApplication.Controllers
{
    public class TopicController : Controller
    {
        HttpClient client;
        HttpResponseMessage Response;
        public TopicController()
        {
           

            client = new HttpClient();
            client.BaseAddress = new Uri("http://pi-net-service-dev.eu-west-1.elasticbeanstalk.com/api/");
            client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
        }

        // GET: Topic
        public ActionResult Index(string searchString)
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            client.DefaultRequestHeaders.Add("Authorization", "Bearer " + Session["token"]);



            if (string.IsNullOrEmpty(searchString) )
            {
                
                Response = client.GetAsync("topic").Result;
                string res = Response.Content.ReadAsStringAsync().Result;
                List<TopicModel> tm = JsonConvert.DeserializeObject<List<TopicModel>>(res);
                return View(tm);
                
            }
            else
            {
                
                Response = client.GetAsync("topic?topic=" + searchString).Result;
                string res = Response.Content.ReadAsStringAsync().Result;
                List<TopicModel> tm = JsonConvert.DeserializeObject<List<TopicModel>>(res);
                
                 return View(tm);

            }


        }


        // GET: Topic/Details/5
        public ActionResult Details(int id)
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            client.DefaultRequestHeaders.Add("Authorization", "Bearer " + Session["token"]);

            Response = client.GetAsync("topic/" + id).Result;
            string res = Response.Content.ReadAsStringAsync().Result;
            TopicModel tm = JsonConvert.DeserializeObject<TopicModel>(res);

            //return po.Questions.ToList()[0].Content;

            return View(tm);
        }

        // GET: Topic/Create
        public ActionResult Create()
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            client.DefaultRequestHeaders.Add("Authorization", "Bearer " + Session["token"]);

            return View();
        }

        // POST: Topic/Create
        [HttpPost]
        public ActionResult Create(TopicModel tm, HttpPostedFileBase file)
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            client.DefaultRequestHeaders.Add("Authorization", "Bearer " + Session["token"]);


            if (file == null || file.ContentLength <= 0)
            {
                // return "bad request";
                return RedirectToAction("Create");
            }

            
                tm.CreatedOn = DateTime.Now;
                tm.ImageURI = DateTime.Now.ToString("yyyymmddMMss") + System.IO.Path.GetExtension(file.FileName);
                file.SaveAs(Server.MapPath("~/Content/uploaded_topic_images/") + tm.ImageURI);


                var obj = JsonConvert.SerializeObject(tm);
            var buffer = System.Text.Encoding.UTF8.GetBytes(obj);
            var byteContent = new ByteArrayContent(buffer);
            byteContent.Headers.ContentType = new MediaTypeHeaderValue("application/json");

            Response = client.PostAsync("topic", byteContent).Result;

            return RedirectToAction("Index");
        }

        // GET: Topic/Edit/5
        public ActionResult Edit(int id)
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            client.DefaultRequestHeaders.Add("Authorization", "Bearer " + Session["token"]);

            Response = client.GetAsync("topic/" + id).Result;
            string res = Response.Content.ReadAsStringAsync().Result;
            TopicModel tm = JsonConvert.DeserializeObject<TopicModel>(res);


            return View(tm);
        }

        // POST: Topic/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, TopicModel tm)
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            client.DefaultRequestHeaders.Add("Authorization", "Bearer " + Session["token"]);
            try
            {
                var obj = JsonConvert.SerializeObject(tm);
                var buffer = System.Text.Encoding.UTF8.GetBytes(obj);
                var byteContent = new ByteArrayContent(buffer);
                byteContent.Headers.ContentType = new MediaTypeHeaderValue("application/json");

                Response = client.PutAsync("topic/" + id, byteContent).Result;

                return RedirectToAction("Index");
                //return Response.Content.ReadAsStringAsync();
                //return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Topic/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Topic/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            if (Session["token"] == null)
            {
                TempData["err_auth_msg"] = "you are not authenticated to access that page";
                return RedirectToAction("index", "Auth");
            }

            JWToken token = new JWToken() { Token = Session["token"].ToString() };
            ViewBag.tenantname = token.getTenantFromToken().Name;
            ViewBag.tenantcolor = token.getTenantFromToken().CustemColor;
            ViewBag.userimage = token.getUserFromToken().ProfileImageURL;
            ViewBag.username = token.getUserFromToken().username;
            ViewBag.userid = token.getUserFromToken().Id;
            client.DefaultRequestHeaders.Add("Authorization", "Bearer " + Session["token"]);

            try
            {
                client.DeleteAsync("topic/" + id);

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }


        /* public ActionResult search(string topic)
         {
             Response = client.GetAsync("topic?topic=" + topic).Result;

MainApplication/Views/Topic/Create.cshtml
@model MainApplication.Models.TopicModel

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Create</h2>


@using (Html.BeginForm(null, null, FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>TopicModel</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.Title, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Title, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Title, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Body, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Body, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Body, "", new { @class = "text-danger" })
            </div>
        </div>


        <div class="form-group">
          <!--  @Html.LabelFor(model => model.ImageURI, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ImageURI, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ImageURI, "", new { @class = "text-danger" })
        </div> -->
            <fieldset class="form-group">
                <label for="exampleInputFile">Image Uri</label>
                <input type="file" class="form-control-file" id="exampleInputFile" name="file">
                <small class="text-help">This is some placeholder block-level help text for the above input. It's a bit lighter and easily wraps to a new line.</small>
            </fieldset>
        </div>


        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-success try-sweet-successMessage" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

MainApplication/Views/Topic/Delete.cshtml
@model MainApplication.Models.TopicModel

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>TopicModel</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Title)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Title)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Body)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Body)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.CreatedOn)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CreatedOn)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ImageURI)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ImageURI)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.UserId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.UserId)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-danger" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

MainApplication/Views/Topic/Edit.cshtml
@model MainApplication.Models.TopicModel

@{
    ViewBag.Title = "Edit";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Edit</h2>


@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>TopicModel</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.Id)

        <div class="form-group">
            @Html.LabelFor(model => model.Title, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Title, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Title, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Body, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Body, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Body, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.CreatedOn, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.CreatedOn, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.CreatedOn, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ImageURI, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ImageURI, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ImageURI, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.UserId, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.UserId, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.UserId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-success" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

MainApplication/Views/Topic/search.cshtml
@model IEnumerable<MainApplication.Models.TopicModel>

@{
    ViewBag.Title = "search";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>search</h2>

<p>
    @Html.ActionLink("Create New", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Title)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Body)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.CreatedOn)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.ImageURI)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.UserId)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.Title)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Body)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.CreatedOn)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.ImageURI)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.UserId)
        </td>
        <td>
            @Html.ActionLink("Edit", "Edit", new { id=item.Id }) |
            @Html.ActionLink("Details", "Details", new { id=item.Id }) |
            @Html.ActionLink("Delete", "Delete", new { id=item.Id })
        </td>
    </tr>
}

</table>

<div class="container-fluid">

    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="instructor-dashboard.html">Home</a></li>
        <li class="breadcrumb-item active">Forum</li>
    </ol>
    <h1 class="page-heading">Forum</h1>
    <div class="row">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">
                    <div class="media">
                        <div class="media-body media-middle">
                            <h4 class="card-title">General</h4>
                            <p class="card-subtitle">All non-course topics.</p>
                        </div>
                        <div class="media-right media-middle">
                            <a href="Topic/Create" class="btn btn-success btn-sm"><i class="material-icons">add</i>Add Topic</a>
                        </div>
                    </div>
                </div>

                <ul class="list-group list-group-fit">
                    @foreach (var item in Model)
                    {
                        <li class="list-group-item forum-thread">
                            <div class="media align-items-center">
                                <div class="media-left">
                                    <div class="forum-icon-wrapper">
                                        <a href="instructor-forum-thread.html" class="forum-thread-icon">
                                            <i class="material-icons">description</i>
                                        </a>
                                        <a href="#public-profile" class="forum-thread-user">
                                            <img src="~/Content/images/guy-8.jpg" alt="" width="20" class="rounded-circle">
                                        </a>
                                    </div>
                                </div>
                                <div class="media-body">
                                    <a href="/topic/Details/@item.Id">@Html.DisplayFor(modelItem => item.Title)</a><br>
                                    <small>Poster: <a href="#">@Html.DisplayFor(modelItem => item.Publisher.username)</a></small>
                                </div>
                                <div class="media-right">
                                    <div style="width:80px;" class="text-right">
                                        <small class="text-muted-light">@Html.DisplayFor(modelItem => item.CreatedOn)</small>
                                    </div>
                                </div>
                            </div>
                        </li> }
                    <!--    <li class="list-group-item forum-thread">
                            <div class="media align-items-center">
                                <div class="media-left">
                                    <div class="forum-icon-wrapper">
                                        <a href="instructor-forum-thread.html" class="forum-thread-icon">
                                            <i class="material-icons">description</i>
                                        </a>
                                        <a href="#public-profile" class="forum-thread-user">
                                            <img src="assets/images/people/50/guy-4.jpg" alt="" width="20" class="rounded-circle">
                                        </a>
                                    </div>
                                </div>
                                <div class="media-body">
                                    <a href="instructor-forum-thread.html">Can someone help me with the basic Setup?</a><br>
                                    <small>posted by <a href="instructor-profile.html">Adrian D.</a></small>
                                </div>
                                <div class="media-right">
                                    <div style="width:80px;" class="text-right">
                                        <small class="text-muted-light">5 min ago</small>
                                    </div>
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item forum-thread">
                            <div class="media align-items-center">
                                <div class="media-left">
                                    <div class="forum-icon-wrapper">
                                        <a href="instructor-forum-thread.html" class="forum-thread-icon">
                                            <i class="material-icons">description</i>
                                        </a>
                                        <a href="#public-profile" class="forum-thread-user">
                                            <img src="assets/images/people/50/guy-2.jpg" alt="" width="20" class="rounded-circle">
                                        </a>
                                    </div>
                                </div>
                                <div class="media-body">
                                    <a href="instructor-forum-thread.html">I think this is the right way?</a><br>
                                    <small>replied by <a href="#">Michael D.</a></small>
                                </div>
                                <div class="media-right">
                                    <div style="width:80px;" class="text-right">
                                        <small class="text-muted-light">5 min ago</small>
                                    </div>
                                </div>
                            </div>
                        </li> -->
                </ul>
            </div>

            <!--  <div class="card">
                  <div class="card-header">
                      <div class="media">
                          <div class="media-body media-middle">
                              <h4 class="card-title">Lessons</h4>
                              <p class="card-subtitle">Course related topics.</p>
                          </div>
                          <div class="media-right media-middle">
                              <a href="#" class="btn btn-white btn-sm"><i class="material-icons">add</i></a>
                          </div>
                      </div>
                  </div>
                  <ul class="list-group list-group-fit">
                      <li class="list-group-item forum-thread">
                          <div class="media align-items-center">
                              <div class="media-left media-middle">
                                  <div class="forum-icon-wrapper">
                                      <a href="instructor-forum-thread.html" class="forum-thread-icon">
                                          <i class="material-icons">description</i>
                                      </a>
                                      <a href="#public-profile" class="forum-thread-user">
                                          <img src="assets/images/people/50/guy-7.jpg" alt="" width="20" class="rounded-circle">
                                      </a>
                                  </div>
                              </div>
                              <div class="media-body media-middle">
                                  <a href="instructor-forum-thread.html">Getting around AngularJS</a><br>
                                  <small>replied by <a href="instructor-profile.html">Adrian D.</a></small>
                              </div>
                              <div class="media-right media-middle">
                                  <div style="width:80px;" class="text-right">
                                      <small class="text-muted-light">5 min ago</small>
                                  </div>
                              </div>
                          </div>
                      </li>
                      <li class="list-group-item forum-thread">
                          <div class="media align-items-center">
                              <div class="media-left media-middle">
                                  <div class="forum-icon-wrapper">
                                      <a href="instructor-forum-thread.html" class="forum-thread-icon">
                                          <i class="material-icons">description</i>
                                      </a>
                                      <a href="#public-profile" class="forum-thread-user">
                                          <img src="assets/images/people/50/guy-8.jpg" alt="" width="20" class="rounded-circle">
                                      </a>
                                  </div>
                              </div>
                              <div class="media-body media-middle">
                                  <a href="instructor-forum-thread.html">Responsive Bootstrap Question</a><br>
                                  <small>posted by <a href="instructor-profile.html">Adrian D.</a></small>
                              </div>
                              <div class="media-right media-middle">
                                  <div style="width:80px;" class="text-right">
                                      <small class="text-muted-light">5 min ago</small>
                                  </div>
                              </div>
                          </div>
                      </li>
                      <li class="list-group-item forum-thread">
                          <div class="media align-items-center">
                              <div class="media-left media-middle">
                                  <div class="forum-icon-wrapper">
                                      <a href="instructor-forum-thread.html" class="forum-thread-icon">
                                          <i class="material-icons">description</i>
                                      </a>
                                      <a href="#public-profile" class="forum-thread-user">
                                          <img src="assets/images/people/50/guy-5.jpg" alt="" width="20" class="rounded-circle">
                                      </a>
                                  </div>
                              </div>
                              <div class="media-body media-middle">
                                  <a href="instructor-forum-thread.html">Can someone help me with the basic Setup?</a><br>
                                  <small>replied by <a href="instructor-profile.html">Adrian D.</a></small>
                              </div>
                              <div class="media-right media-middle">
                                  <div style="width:80px;" class="text-right">
                                      <small class="text-muted-light">5 min ago</small>
                                  </div>
                              </div>
                          </div>
                      </li>
                  </ul>
              </div> -->
        </div>
        <div class="col-md-4">
            <div class="card">
                <div class="card-body text-center">
                    <form method="get" action="@Url.Action("search","Topic")">
                        <div class="form-group">

                            <input id="forumSearch" type="text" class="form-control" placeholder="Type to search">
                        </div>
                        <button class="btn" type="submit"><i class="material-icons">seach</i></button>
                    </form>
                </div>

            </div>

            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">Categories</h4>
                </div>
                <ul class="list-group list-group-fit">
                    <li class="list-group-item active">
                        <a href="#">All Topics</a>
                    </li>
                    <li class="list-group-item">
                        <a href="#">General</a>
                    </li>
                    <li class="list-group-item">
                        <a href="#">Lessons</a>
                    </li>
                    <li class="list-group-item">
                        <a href="#">Support</a>
                    </li>
                </ul>
            </div>
        </div>
    </div>

</div>